
(* CSE505, Fall 2005, Homework 1 Sample Solution *)
exception DequeueEmpty

type 'a mylist1 = Empty | Node of 'a * 'a mylist1
type 'a queue1  = 'a mylist1 * 'a mylist1

let mylist_rev lst =
  let rec f lst acc =
    match lst with
      Empty -> acc
    | Node(hd,tl) -> f tl (Node(hd,acc)) in
  f lst Empty

let rec mylist_map f lst =
  match lst with
    Empty -> Empty
  | Node(hd,tl) -> Node(f hd, mylist_map f tl)

let empty_queue1 = (Empty,Empty)

let enq1 (front,back) x = (front,Node(x,back))

let rec deq1 (front,back) = (* 'a queue1 -> 'a * ('a queue1) *)
  match front with
    Empty -> 
      if back=Empty 
      then raise DequeueEmpty 
      else deq1(mylist_rev back, Empty)
  | Node(hd,tl) -> (hd, (tl, back))

let map1 f (front,back) = (mylist_map f front, mylist_map f back)

let inc1 = map1 (fun x -> x + 1)

type 'a queue2 = 'a list * 'a list

let empty_queue2 = ([],[])

let enq2 (front,back) x = (front, x::back)

let rec deq2 (front,back) =
  match front with
    [] -> 
      if back=[]
      then raise DequeueEmpty 
      else deq2(List.rev back, [])
  | hd::tl -> (hd, (tl, back))

let map2 f (front,back) = (List.map f front, List.map f back)

type 'a queue_impl = QI of 'a * ('a queue_impl option ref)
type 'a queue3 = ('a queue_impl * 'a queue_impl option ref) option ref

let empty_queue3 () : 'a queue3 = ref None

let enq3 (q : 'a queue3) x = 
  let newBack = ref None in
  let newNode = QI(x, newBack) in
  (match !q with
    None -> q := Some(newNode,newBack)
  | Some(front,back) ->
      back := Some newNode; 
      q    := Some(front,newBack))
  
let deq3 (q : 'a queue3) =
  match !q with
    None -> raise DequeueEmpty
  | Some(QI(hd,tl),back) ->
      ((match !tl with
	None    -> q := None
      |	Some q2 -> q := Some(q2,back));
      hd)

let map3 f (q : 'a queue3) : 'b queue3 =
  match !q with
    None -> empty_queue3 ()
  | Some(front,back) ->
      let newBack = ref None in
      let rec loop front =
	match front with
	  QI(hd, {contents=None})    -> QI(f hd, newBack)
	| QI(hd, {contents=Some tl}) -> QI(f hd, ref (Some (loop tl))) in
      ref (Some(loop front, newBack))

(* extra credit *)
type 'a q = { enq : 'a -> 'a q;
              deq : unit -> ('a * 'a q) }

let qmaker1 () =
  let rec f elts =
  { enq = (fun x  -> f (enq1 elts x));
    deq = (fun () -> let (x,tl) = deq1 elts in (x, f tl)) } in
  f empty_queue1

let qmaker2 () =
  let rec f elts =
  { enq = (fun x  -> f (enq2 elts x));
    deq = (fun () -> let (x,tl) = deq2 elts in (x, f tl)) } in
  f empty_queue2

let qmaker3 () =
  let q = empty_queue3 () in
  let rec v =
    { enq = (fun x  -> enq3 q x; v);
      deq = (fun () -> (deq3 q, v)) } in
  v

let is_functional f = (* may not use pointer equality on f *)
  let q = f() in
  let q2 = q.enq 1 in
  let q3 = q.enq 2 in
  let (x,_) = q3.deq () in
  x = 2

